package reading_pcap;
import java.util.regex.Pattern;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import org.jnetpcap.Pcap;
import org.jnetpcap.PcapHeader;
import org.jnetpcap.packet.JPacket;
import org.jnetpcap.packet.JPacketHandler;
import org.jnetpcap.protocol.tcpip.Http;
import org.jnetpcap.protocol.tcpip.Tcp;
import org.jnetpcap.packet.Payload;
import java.sql.Timestamp;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;

public class HTTPPayloadPost
{
        static int first_packet=0;
        static long first_packet_timestamp=0;
        static int count=0;
        static String st;
        static String result;
        static int content_length=0;
	public static void main(String[] args)
	{
                
		String FILENAME = "D:\\3_req_only.pcap";
		final StringBuilder errbuf = new StringBuilder();
		final Pcap pcap = Pcap.openOffline(FILENAME, errbuf);

		if (pcap == null)
		{
			System.err.println(errbuf);
			return;
		}
		pcap.loop(-1, new JPacketHandler<StringBuilder>()
		{
                    final Tcp tcp = new Tcp();
                   // final Http http = new Http();
                    //final Payload pl=new Payload();
                    public void nextPacket(JPacket packet, StringBuilder errbuf)
			{
                                if (first_packet==0)
                                {
                                    //System.out.println(first_packet);
                                    first_packet_timestamp=packet.getCaptureHeader().timestampInMicros();
                                    first_packet=1;
                                }
                                
                                //boolean b = hexdump.contains("GET");
                                /*if (b)
                                {
                                      char[] hexArray = hexdump.toCharArray();
                                      System.out.println(hexdump);
                                      char ch= packet.getUTF8Char(1769);
                                      System.out.println(ch);
                                      System.out.println(hexdump.indexOf("keep-alive"));
                                      System.out.println(hexArray[hexdump.indexOf("keep-alive")+87]);
                                }       
				//System.out.println("a"); */
                                if (packet.getCaptureHeader().timestampInMicros()-first_packet_timestamp<600000000)
                                {
                                    String hexdump = packet.toHexdump(packet.size(), true, true, true);
                                    /*char[] hexArray = http.toString().toCharArray();
                                    String s=http.toString();
                                    System.out.printf("%s%n", http);
                                    System.out.printf("http header::%s%n", hexArray[http.toString().length()-1]);*/
                                    //System.out.printf("%s%n",hexdump);
                                    if(hexdump.contains("POST"))
                                    {
                                        //System.out.println(packet.getHeader(tcp).getPayloadLength());
                                        byte[] payload=packet.getHeader(tcp).getPayload();
                                       // System.out.println("gi");
                                    String temp=new String(payload,StandardCharsets.UTF_8);
                                    //System.out.printf("%s%n",temp);
                                    //x=x+packet.getCaptureHeader().timestampInMicros();
                                    //System.out.println(packet.getCaptureHeader().timestampInMicros());
                                    
                                       String pattern = "Content-Length: (.+?)\r\n";
                                       String pattern1 = "Content-length: (.+?)\r\n";
                                       Pattern r = Pattern.compile(pattern);
                                       Pattern r1 = Pattern.compile(pattern1);
                                       Matcher m = r.matcher(temp);
                                       Matcher m1 = r1.matcher(temp);
                                       if (m.find( ))
                                       {
                                            st=m.group(1);
                                       }
                                       else if (m1.find())
                                       {
                                           st=m1.group(1);
                                       }
                                       content_length=Integer.parseInt(st);
                                       result = temp.substring(temp.indexOf("\r\n\r\n")+4, temp.length());
                                       System.out.print(result.length());
                                       System.out.print(" ");
                                       System.out.println(content_length);
                                       System.out.println();
                                       if(content_length==result.length())
                                       {
                                        count+=1;
                                        //System.out.println("n");
                                       }
                                         
                                    }
                                }
                                else
                                {
                                    first_packet_timestamp+=600000000;
                                    //System.out.println(count);
                                    try(PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("D:\\3_req_only_post.txt", true))))
                                        {
                                            writer.print(count);
                                            writer.println("");
                                            //writer.close();
                                            
                                            count=0;
                                        } catch (FileNotFoundException | UnsupportedEncodingException ex) {
                                            Logger.getLogger(HttpPayload.class.getName()).log(Level.SEVERE, null, ex);
                                        } catch (IOException ex) {    
                                        Logger.getLogger(HttpPayload.class.getName()).log(Level.SEVERE, null, ex);
                                    }    
                                }
			}
                       
		}, errbuf);
                //System.out.println(count);
                try(PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("D:\\3_req_only_post.txt", true))))
                {
                    writer.print(count);
                    writer.println("");
                    //riter.close();
                    count=0;
                } catch (FileNotFoundException | UnsupportedEncodingException ex) {
                    Logger.getLogger(HttpPayload.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IOException ex) {    
                Logger.getLogger(HttpPayload.class.getName()).log(Level.SEVERE, null, ex);
            }
}
}